YAML Form
---------


### About this Module

The YAML Form module is a form builder and submission manager for Drupal 8.

The primary use case for this module is to:

- **Build** a new form or duplicate an existing template
- **Publish** the form as a page, node, or block
- **Collect** submissions
- **Send** confirmations and notifications
- **Review** submissions online
- **Download** submissions as a CSV


### Demo

<div style="position: relative; padding-bottom: 56.25%; padding-top: 30px; height: 0; overflow: hidden;">
  <iframe width="560" height="315" src="https://www.youtube.com/embed/9jSOOEpzAy8" frameborder="0" allowfullscreen style="position: absolute; top: 0; left: 0; width: 100%; height: 100%;"></iframe>
</div> 
<br/>

> Evaluate this project online using [simplytest.me](https://simplytest.me/project/yamlform).

> [Watch a demo](http://youtu.be/9jSOOEpzAy8) of the YAML Form module.


### Goals

- A comprehensive form and survey building solution for Drupal 8. 
- A stable, maintainable, and tested API for building forms and handling submission.
- A pluggable/extensible API for custom form elements and submission handling. 
 

### Documentation

The YAML Form module's documentation is still under development. The YAML form 
module has a dedicated website that provides 
a [features summary](http://yamlform.io/features/), 
[installation instructions](http://yamlform.io/support/installation/),
[FAQs](http://yamlform.io/support/faq/),
and [more...](http://yamlform.io/yamlform/).


### Releases

Even though the YAML Form module is still under active development with
regular [beta releases](https://www.drupal.org/documentation/version-info/alpha-beta-rc),
all existing configuration and submission data will be maintained and updated 
between releases.  **APIs can and will be changing** while this module moves 
from beta releases to a final release candidate. 

Simply put, if you install and use the YAML Form module out of the box AS-IS, you _should_ be okay.  Once you start extending forms with plugins, 
altering  hooks, and overriding templates, you will need to read each release's 
notes and assume that _things will be changing_.


### Similar Projects

- [Comparison of Form Building Modules](https://www.drupal.org/node/2083353)
- [Contact](https://www.drupal.org/documentation/modules/contact) 
    - [Contact Storage](https://www.drupal.org/project/contact_storage)
    - [Contact module 8.1 and beyond roadmap](https://www.drupal.org/node/2582955)
    - [Goodbye Webform? Contact Forms Are In the Drupal 8 Core](https://www.ostraining.com/blog/drupal/drupal-8-contact-forms/)
- [Eform](https://www.drupal.org/project/eform)
    - [When to use Entityform](https://www.drupal.org/node/1540680)
- [Webform](https://www.drupal.org/project/webform) 
    - [Port Webform to Drupal 8](https://www.drupal.org/node/2075941)
